//	This source and encryption method apply to GNU General Public License.
//			Copyright (C) 2006 Jasenko Dzinleski

//		This program is free software; you can redistribute it
//	and/or modify it under the terms of the GNU General Public License as
//	published by the Free Software Foundation; either version 2 of the
//	License, or (at your option) any later version.

//	This program is distributed in the hope that it will be useful, but
//	WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
//	General Public License for more details.

//	You should have received a copy of the GNU General Public License along
//	with this program; if not, write to the Free Software Foundation, Inc.,
//	51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.

// 
//		Encryption routine written by Dzinleski jasenko July,2007
//							
//

//-----------------------------------------------------
//
//		mariaRandom Generator
//
//
//		copyright Dzinleski Jasenko 2007
//-----------------------------------------------------


#include <stdio.h>
#include <string.h>
#include <math.h>

#define seedx 		31193
#define	tdiv 		113

#define outr 		133
#define inr  		7

#define	rang 		10000
#define	rdiv 		10

#define	tc		100
#define	outm		1000

#define			op_A(w,x,y,z)(((((w&0x0000ffff)<<16)|x)&0xffff0000)|((((y&0x0000ffff)<<16)|z)&0x0000ffff))
#define			op_B(w,x,y,z)(((((x&0x0000ffff)<<16)|w)&0xffff0000)|((((z&0x0000ffff)<<16)|y)&0x0000ffff))
#define			op_E(w,x,y,z)(op_A(w,x,y,z)>op_B(w,x,y,z)?op_A(w,x,y,z):op_B(w,x,y,z))

bool	df=false;		

int	htable[1000][4];
int	hti_dmin=0,hti_dmax=0,hti_rmin=0,hti_rmax=0;

long	seeda,seedb,seedc,seedd;



long	htl[1000][4+1];
int	htli=0;

char	einfn[256]="cin.txt";
char	eoutfn[256]="eout.txt";
char	doutfn[256]="decrypted.txt";

FILE	*f1,*f2,*f3,*f5;

int mrandom_dmin(long seed)
{
	long	k;

	int 	i,j,l,n;

	double	v11,v12;
	long	v51,v52;

	int	l1n,h1n,l2n,h2n,mv;

	int	rs[tc][3];
	int	rsi=0;

	int	minmv,minl;

	k=seed/rdiv;
	
	for(i=3;i<outr;++i)
	{
		for(j=3;j<inr;++j)
		{
			v11=1000*j/i;
			v12=seed/v11;
			++k;

			l1n=0;h1n=0;l2n=0;h2n=0;n=0;rsi=0;
			while(n<tc)
			{

				v51=v12*k;
				v52=v12*k/rang;
				v52=v52*rang;
				v52=v52-v51;
				++k;

				if(v52<0){v52*=-1;}
				mv=v52%tdiv;

				if(mv>=0&&mv<50)
				{
					if(mv>=0&&mv<25){++l1n;rs[rsi][0]=v52;rs[rsi][1]=1;rs[rsi][2]=mv;++rsi;}else{
						++h1n;rs[rsi][0]=v52;rs[rsi][1]=2;rs[rsi][2]=mv;++rsi;}
				}else{
					if(mv>=50&&mv<75){++l2n;rs[rsi][0]=v52;rs[rsi][1]=3;rs[rsi][2]=mv;++rsi;}else{
						++h2n;rs[rsi][0]=v52;rs[rsi][1]=4;rs[rsi][2]=mv;++rsi;}
				}

				++n;
			}

			minmv=999;
			for(l=0;l<rsi;++l)
			{
				if(n=0||l==0){n=rs[l][1];continue;}
				if(n==rs[l][1]||n+1==rs[l][1]||n-1==rs[l][1]){n=rs[l][1];}else{

					if(minmv>rs[l][2]){minmv=rs[l][2];minl=l;}
					n=0;
				}	
			}
			if(df){printf(" %d",rs[minl][0]%outm);}
			htable[hti_dmin][0]=rs[minl][0]%outm;++hti_dmin;
		}
		k=seed/rdiv;
	}

	return(0);
}

int mrandom_dmax(long seed)
{
	long	k;

	int 	i,j,l,n;

	double	v11,v12;
	long	v51,v52;

	int	l1n,h1n,l2n,h2n,mv;

	int	rs[tc][3];
	int	rsi=0;

	int	maxmv,maxl;

	k=seed/rdiv;
	
	for(i=3;i<outr;++i)
	{
		for(j=3;j<inr;++j)
		{
			v11=1000*j/i;
			v12=seed/v11;
			++k;

			l1n=0;h1n=0;l2n=0;h2n=0;n=0;rsi=0;
			while(n<tc)
			{

				v51=v12*k;
				v52=v12*k/rang;
				v52=v52*rang;
				v52=v52-v51;
				++k;

				if(v52<0){v52*=-1;}
				mv=v52%tdiv;

				if(mv>=0&&mv<50)
				{
					if(mv>=0&&mv<25){++l1n;rs[rsi][0]=v52;rs[rsi][1]=1;rs[rsi][2]=mv;++rsi;}else{
						++h1n;rs[rsi][0]=v52;rs[rsi][1]=2;rs[rsi][2]=mv;++rsi;}
				}else{
					if(mv>=50&&mv<75){++l2n;rs[rsi][0]=v52;rs[rsi][1]=3;rs[rsi][2]=mv;++rsi;}else{
						++h2n;rs[rsi][0]=v52;rs[rsi][1]=4;rs[rsi][2]=mv;++rsi;}
				}

				++n;
			}

			maxmv=0;
			for(l=0;l<rsi;++l)
			{
				if(n=0||l==0){n=rs[l][1];continue;}
				if(n==rs[l][1]||n+1==rs[l][1]||n-1==rs[l][1]){n=rs[l][1];}else{

					if(maxmv<rs[l][2]){maxmv=rs[l][2];maxl=l;}
					n=0;
				}	
			}
			if(df){printf(" %d",rs[maxl][0]%outm);}
			htable[hti_dmax][1]=rs[maxl][0]%outm;++hti_dmax;
		}
		k=seed/rdiv;
	}

	return(0);
}

int mrandom_rmin(long seed)
{
	long	k;

	int 	i,j,l,n;

	double	v11,v12;
	long	v51,v52;

	int	l1n,h1n,l2n,h2n,mv;

	int	rs[tc][3];
	int	rsi=0;

	int	minmv,minl;

	k=seed/rdiv;
	
	for(i=3;i<outr;++i)
	{
		for(j=3;j<inr;++j)
		{
			v11=1000*j/i;
			v12=seed/v11;
			++k;

			l1n=0;h1n=0;l2n=0;h2n=0;n=0;rsi=0;
			while(n<tc)
			{

				v51=v12*k;
				v52=v12*k/rang;
				v52=v52*rang;
				v52=v52-v51;
				++k;

				if(v52<0){v52*=-1;}
				mv=v52%tdiv;

				if(mv>=0&&mv<50)
				{
					if(mv>=0&&mv<25){++l1n;rs[rsi][0]=v52;rs[rsi][1]=1;rs[rsi][2]=mv;++rsi;}else{
						++h1n;rs[rsi][0]=v52;rs[rsi][1]=2;rs[rsi][2]=mv;++rsi;}
				}else{
					if(mv>=50&&mv<75){++l2n;rs[rsi][0]=v52;rs[rsi][1]=3;rs[rsi][2]=mv;++rsi;}else{
						++h2n;rs[rsi][0]=v52;rs[rsi][1]=4;rs[rsi][2]=mv;++rsi;}
				}

				++n;
			}

			minmv=999;
			for(l=0;l<rsi;++l)
			{
				if(n==rs[l][1]||n+1==rs[l][1]||n-1==rs[l][1])
				{
					n=rs[l][1];
					if(minmv>rs[l][2]){minmv=rs[l][2];minl=l;}

				}else{n=0;}	
			}
			if(df){printf(" %d",rs[minl][0]%outm);}
			htable[hti_rmin][2]=rs[minl][0]%outm;++hti_rmin;
		}
		k=seed/rdiv;
	}

	return(0);
}

int mrandom_rmax(long seed)
{
	long	k;

	int 	i,j,l,n,c;

	double	v11,v12;
	long	v51,v52;

	int	l1n,h1n,l2n,h2n,mv;

	int	rs[tc][3];
	int	rsi=0;

	int	maxmv,maxl;

	k=seed/rdiv;
	
	for(i=3;i<outr;++i)
	{
		for(j=3;j<inr;++j)
		{
			v11=1000*j/i;
			v12=seed/v11;
			++k;

			l1n=0;h1n=0;l2n=0;h2n=0;n=0;rsi=0;
			while(n<tc)
			{

				v51=v12*k;
				v52=v12*k/rang;
				v52=v52*rang;
				v52=v52-v51;
				++k;

				if(v52<0){v52*=-1;}
				mv=v52%tdiv;

				if(mv>=0&&mv<50)
				{
					if(mv>=0&&mv<25){++l1n;rs[rsi][0]=v52;rs[rsi][1]=1;rs[rsi][2]=mv;++rsi;}else{
						++h1n;rs[rsi][0]=v52;rs[rsi][1]=2;rs[rsi][2]=mv;++rsi;}
				}else{
					if(mv>=50&&mv<75){++l2n;rs[rsi][0]=v52;rs[rsi][1]=3;rs[rsi][2]=mv;++rsi;}else{
						++h2n;rs[rsi][0]=v52;rs[rsi][1]=4;rs[rsi][2]=mv;++rsi;}
				}

				++n;
			}

			maxmv=0;
			for(l=0;l<rsi;++l)
			{
				if(n=0||l==0){n=rs[l][1];continue;}
				if(n==rs[l][1]||n+1==rs[l][1]||n-1==rs[l][1])
				{
					n=rs[l][1];
					if(maxmv<rs[l][2]){maxmv=rs[l][2];maxl=l;}

				}else{n=0;}
			}
			if(df){printf(" %d",rs[maxl][0]%outm);}
			htable[hti_rmax][3]=rs[maxl][0]%outm;++hti_rmax;
		}
		k=seed/rdiv;
	}

	return(0);
}

int encrypt()
{

	int	i,l,ai,bi,fbyte;

	printf("Encrypting...\n");

	mrandom_dmin(seeda);
	mrandom_dmax(seeda);	
	mrandom_rmin(seeda);	
	mrandom_rmax(seeda);	

	for(i=0;i<hti_rmax;++i)
	{
		//printf("%03d. %05d %05d %05d %05d\n",i,htable[i][0],htable[i][1],htable[i][2],htable[i][3]);
		htl[htli][0]=op_E(htable[i][0],htable[i][1],htable[i][2],htable[i][3]);
		//printf("%d\n",htl[htli][0]);
		++htli;
	}

	hti_dmin=0;hti_dmax=0;hti_rmin=0;hti_rmax=0;
	htli=0;
	mrandom_dmin(seedb);
	mrandom_dmax(seedb);	
	mrandom_rmin(seedb);	
	mrandom_rmax(seedb);	

	for(i=0;i<hti_rmax;++i)
	{
		//printf("%03d. %05d %05d %05d %05d\n",i,htable[i][0],htable[i][1],htable[i][2],htable[i][3]);
		htl[htli][1]=op_E(htable[i][0],htable[i][1],htable[i][2],htable[i][3]);
		//printf("%d\n",htl[htli][1]);
		++htli;
	}

	hti_dmin=0;hti_dmax=0;hti_rmin=0;hti_rmax=0;
	htli=0;
	mrandom_dmin(seedc);
	mrandom_dmax(seedc);	
	mrandom_rmin(seedc);	
	mrandom_rmax(seedc);	

	for(i=0;i<hti_rmax;++i)
	{
		//printf("%03d. %05d %05d %05d %05d\n",i,htable[i][0],htable[i][1],htable[i][2],htable[i][3]);
		htl[htli][2]=op_E(htable[i][0],htable[i][1],htable[i][2],htable[i][3]);
		//printf("%d\n",htl[htli][2]);
		++htli;
	}

	hti_dmin=0;hti_dmax=0;hti_rmin=0;hti_rmax=0;
	htli=0;
	mrandom_dmin(seedd);
	mrandom_dmax(seedd);	
	mrandom_rmin(seedd);	
	mrandom_rmax(seedd);	

	for(i=0;i<hti_rmax;++i)
	{
		//printf("%03d. %05d %05d %05d %05d\n",i,htable[i][0],htable[i][1],htable[i][2],htable[i][3]);
		htl[htli][3]=op_E(htable[i][0],htable[i][1],htable[i][2],htable[i][3]);
		//printf("%d\n",htl[htli][3]);
		++htli;
	}

	htli=0;

	for(i=0;i<hti_rmax;++i)
	{
		//printf("%03d. %05d %05d %05d %05d\n",i,htl[i][0],htl[i][1],htl[i][2],htl[i][3]);
		htl[htli][4]=op_E(htl[i][0],htl[i][1],htl[i][2],htl[i][3]);++htli;
		//printf("%03d. %05d\n",i,htl[-1+htli][4]);
	}

	l=0;

	f1=fopen(einfn,"rb");
	if (f1==NULL){printf("No File to Encrypt...\n");return(-1);}
	f2=fopen(eoutfn,"wb");

	ai=fgetc(f1);
	for (i=0;i<htl[l][4]%255;++i)
	{
		++ai;
		if (ai==255+1){ai=0;}
	}
	++l;
	bi=fgetc(f1);
	for (i=0;i<htl[l][4]%255;++i)
	{
		++bi;
		if (bi==255+1){bi=0;}
	}
	fprintf(f2,"%c%c",ai,bi);

	while(!feof(f1))
	{

		++l;
		if (l==htli){l=0;}
		ai=fgetc(f1);if(feof(f1)){continue;}
		for (i=0;i<htl[l][4]%255;++i)
		{
			++ai;
			if (ai==255+1){ai=0;}
		}
		fprintf(f2,"%c",ai);

		++l;
		if (l==htli){l=0;}
		bi=fgetc(f1);if(feof(f1)){continue;}
		for (i=0;i<htl[l][4]%255;++i)
		{
			++bi;
			if (bi==255+1){bi=0;}
		}
		fprintf(f2,"%c",bi);

	}

	fclose(f1);
	fclose(f2);

	return(0);
}

int decrypt()
{
	int	i,l,ai,bi,fbyte;

	printf("Decrypting...\n");

	mrandom_dmin(seeda);
	mrandom_dmax(seeda);	
	mrandom_rmin(seeda);	
	mrandom_rmax(seeda);	

	for(i=0;i<hti_rmax;++i)
	{
		//printf("%03d. %05d %05d %05d %05d\n",i,htable[i][0],htable[i][1],htable[i][2],htable[i][3]);
		htl[htli][0]=op_E(htable[i][0],htable[i][1],htable[i][2],htable[i][3]);++htli;
	}

	hti_dmin=0;hti_dmax=0;hti_rmin=0;hti_rmax=0;
	htli=0;
	mrandom_dmin(seedb);
	mrandom_dmax(seedb);	
	mrandom_rmin(seedb);	
	mrandom_rmax(seedb);	

	for(i=0;i<hti_rmax;++i)
	{
		//printf("%03d. %05d %05d %05d %05d\n",i,htable[i][0],htable[i][1],htable[i][2],htable[i][3]);
		htl[htli][1]=op_E(htable[i][0],htable[i][1],htable[i][2],htable[i][3]);++htli;
	}

	hti_dmin=0;hti_dmax=0;hti_rmin=0;hti_rmax=0;
	htli=0;
	mrandom_dmin(seedc);
	mrandom_dmax(seedc);	
	mrandom_rmin(seedc);	
	mrandom_rmax(seedc);	

	for(i=0;i<hti_rmax;++i)
	{
		//printf("%03d. %05d %05d %05d %05d\n",i,htable[i][0],htable[i][1],htable[i][2],htable[i][3]);
		htl[htli][2]=op_E(htable[i][0],htable[i][1],htable[i][2],htable[i][3]);++htli;
	}

	hti_dmin=0;hti_dmax=0;hti_rmin=0;hti_rmax=0;
	htli=0;
	mrandom_dmin(seedd);
	mrandom_dmax(seedd);	
	mrandom_rmin(seedd);	
	mrandom_rmax(seedd);	

	for(i=0;i<hti_rmax;++i)
	{
		//printf("%03d. %05d %05d %05d %05d\n",i,htable[i][0],htable[i][1],htable[i][2],htable[i][3]);
		htl[htli][3]=op_E(htable[i][0],htable[i][1],htable[i][2],htable[i][3]);++htli;
	}

	htli=0;

	for(i=0;i<hti_rmax;++i)
	{
		//printf("%03d. %05d %05d %05d %05d\n",i,htable[i][0],htable[i][1],htable[i][2],htable[i][3]);
		htl[htli][4]=op_E(htl[i][0],htl[i][1],htl[i][2],htl[i][3]);++htli;
	}

	f2=fopen(eoutfn,"rb");
	if (f2==NULL){printf("No File to Decrypt...\n");return(-1);}
	f5=fopen(doutfn,"wb");

	l=0;

	ai=fgetc(f2);
	for (i=0;i<htl[l][4]%255;++i)
	{
		--ai;
		if (ai==-1){ai=255;}
	}

	++l;
	bi=fgetc(f2);
	for (i=0;i<htl[l][4]%255;++i)
	{
		--bi;
		if (bi==-1){bi=255;}
	}
	fprintf(f5,"%c%c",ai,bi);

	while(!feof(f2))
	{


		++l;
		if (l==htli){l=0;}
		ai=fgetc(f2);if(feof(f2)){continue;}
		for (i=0;i<htl[l][4]%255;++i)
		{
			--ai;
			if (ai==-1){ai=255;}
		}
		fprintf(f5,"%c",ai);

		++l;
		if (l==htli){l=0;}
		bi=fgetc(f2);if(feof(f2)){continue;}
		for (i=0;i<htl[l][4]%255;++i)
		{
			--bi;
			if (bi==-1){bi=255;}
		}
		fprintf(f5,"%c",bi);

	}

	fclose(f2);
	fclose(f5);

	return(0);
}

int main(int argc,char *argv[])
{
	int	i,j,k,l,m,p,c;
	long	lsn=0;

	char	cmd[256];
	char	fn[256];
	char	sn[256];

	char	e0='\0',e1='\0',e2='\0';

	printf("\n\nEncryption Written by Dzinleski Jasenko July,2007 \n\n");
	printf("OS Win32 VRM 1.3.3\n\n");

	for(i=0;i<255;++i){cmd[i]='\0';}
	for(i=1;i<argc;++i)
	{
		if(strlen(argv[i])>0)
		{
			strcpy(cmd,argv[i]);
			if(cmd[0]=='-'&&strlen(cmd)==2)
			{
				if(cmd[1]=='a')
				{
					lsn=0;
					strcpy(sn,argv[i+1]);p=0;
					for(j=strlen(sn)-1;j>=0;--j)
					{
						m=-48+sn[j];
						lsn+=m*pow(10,p);
						++p;
					}
					seeda=lsn;
					//printf("seed: %d\n",lsn);
				}else{
				if(cmd[1]=='b')
				{
					lsn=0;
					strcpy(sn,argv[i+1]);p=0;
					for(j=strlen(sn)-1;j>=0;--j)
					{
						m=-48+sn[j];
						lsn+=m*pow(10,p);
						++p;
					}
					seedb=lsn;
					//printf("seed: %d\n",lsn);
				}else{
				if(cmd[1]=='c')
				{
					lsn=0;
					strcpy(sn,argv[i+1]);p=0;
					for(j=strlen(sn)-1;j>=0;--j)
					{
						m=-48+sn[j];
						lsn+=m*pow(10,p);
						++p;
					}
					seedc=lsn;
					//printf("seed: %d\n",lsn);
				}else{
				if(cmd[1]=='d')
				{
					lsn=0;
					strcpy(sn,argv[i+1]);p=0;
					for(j=strlen(sn)-1;j>=0;--j)
					{
						m=-48+sn[j];
						lsn+=m*pow(10,p);
						++p;
					}
					seedd=lsn;
					//printf("seed: %d\n",lsn);
				}else{
				if(cmd[1]=='e')
				{
					if(argc>i+1&&strlen(argv[i+1])>0)
					{
						strcpy(einfn,argv[i+1]);
						
						for(j=0;j<255;++j){fn[j]='\0';}
						strcpy(fn,argv[i+1]);
						for(l=0;fn[l]!='.';++l){}for(m=0;eoutfn[m]!='.';++m){}
						fn[l]='_';++l;
						for(k=l;k<l+m;++k){fn[k]=eoutfn[k-l];}
						fn[k]='.';fn[++k]='m';fn[++k]='a';fn[++k]='r';
						//printf("%s",fn);
						for(k=0;k<strlen(fn);++k){eoutfn[k]=fn[k];}

						if(seeda>=10000&&seeda<=99999){}else{printf("Nothing to do!\n");return(0);}
						if(seedb>=10000&&seedb<=99999){}else{printf("Nothing to do!\n");return(0);}
						if(seedc>=10000&&seedc<=99999){}else{printf("Nothing to do!\n");return(0);}
						if(seedd>=10000&&seedd<=99999){}else{printf("Nothing to do!\n");return(0);}

						encrypt();
						break;
					}
				}else{
				if(cmd[1]=='f')
				{
					if(argc>i+1&&strlen(argv[i+1])>0)
					{
						for(j=0;j<255;++j){fn[j]='\0';}
						strcpy(fn,argv[i+1]);
						for(l=0;fn[l]!='.';++l){}for(m=0;eoutfn[m]!='.';++m){}
						fn[l]='_';++l;
						for(k=l;k<l+m;++k){fn[k]=eoutfn[k-l];}
						fn[k]='.';fn[++k]='m';fn[++k]='a';fn[++k]='r';
						//printf("%s",fn);
						for(k=0;k<strlen(fn);++k){eoutfn[k]=fn[k];}
						
						for(j=0;j<255;++j){fn[j]='\0';}
						strcpy(fn,argv[i+1]);
						for(l=0;fn[l]!='.';++l){}e0=fn[l+1];e1=fn[l+2];e2=fn[l+3];for(m=0;doutfn[m]!='.';++m){}
						fn[l]='_';++l;
						for(k=l;k<l+m;++k){fn[k]=doutfn[k-l];}
						fn[k]='.';fn[++k]=e0;fn[++k]=e1;fn[++k]=e2;
						//printf("%s",fn);
						for(k=0;k<strlen(fn);++k){doutfn[k]=fn[k];}

						if(seeda>=10000&&seeda<=99999){}else{printf("Nothing to do!\n");return(0);}
						if(seedb>=10000&&seedb<=99999){}else{printf("Nothing to do!\n");return(0);}
						if(seedc>=10000&&seedc<=99999){}else{printf("Nothing to do!\n");return(0);}
						if(seedd>=10000&&seedd<=99999){}else{printf("Nothing to do!\n");return(0);}
					
						decrypt();
						break;

					}else{return(0);}
				}else{
				if(cmd[1]=='h')
				{
					printf("\n\nEncryption Written by Dzinleski Jasenko July,2007 \n\n");
					printf("OS Win32 VRM 1.3.3\n\n");
					printf("\n");
					printf("Password.txt should have at least 50 chrs and no more than 100 chrs...\n");
					printf("r7 -a <seed 1. number> -b <seed 2. number> -c <seed 3. number> -d <seed 4. number> -e <filename to encrypt>\n");
					printf("r7 -a <seed 1. number> -b <seed 2. number> -c <seed 3. number> -d <seed 4. number> -f <encrypted filename>\n");
					printf("\n");
					break;
				}else{
				if(cmd[1]=='l'||cmd[1]=='e')
				{
					printf("\n\nEncryption Written by Dzinleski Jasenko July,2007 \n\n");
					printf("OS Win32 VRM 1.3.3\n\n");
					printf("\n");
					printf("\tThis source and encryption method apply to GNU General Public License.\n");
					printf("\t		Copyright (C) 2005 Jasenko Dzinleski \n");
					printf("\n");
					printf("\t	This program is free software; you can redistribute it\n");
					printf("\tand/or modify it under the terms of the GNU General Public License as\n");
					printf("\tpublished by the Free Software Foundation; either version 2 of the\n");
					printf("\tLicense, or (at your option) any later version.\n");
					printf("\n");
					printf("\tThis program is distributed in the hope that it will be useful, but\n");
					printf("\tWITHOUT ANY WARRANTY; without even the implied warranty of\n");
					printf("\tMERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU\n");
					printf("\tGeneral Public License for more details.\n");
					printf("\n");
					printf("\tYou should have received a copy of the GNU General Public License along\n");
					printf("\twith this program; if not, write to the Free Software Foundation, Inc.,\n");
					printf("\t51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.\n");
					printf("\n");
					break;
				}
				}
				}
				}
				}
				}
				}
				}
			}

		}
	}
	return(0);
}
